/*
 * Copyright 2015 - 2024 gary@drinkingtea.net
 *
 * This Source Code Form is subject to the terms of the Mozilla Public
 * License, v. 2.0. If a copy of the MPL was not distributed with this
 * file, You can obtain one at https://mozilla.org/MPL/2.0/.
 */

#pragma once

#include "point.hpp"
#include "size.hpp"
#include "vec.hpp"

namespace ox {

constexpr Vec2::operator Point() const noexcept {
	return {
			static_cast<int32_t>(x),
			static_cast<int32_t>(y),
	};
}

constexpr Vec2::operator Size() const noexcept {
	return {
			static_cast<int32_t>(x),
			static_cast<int32_t>(y),
	};
}

constexpr Point::operator Vec2() const noexcept {
	return {
			static_cast<float>(x),
			static_cast<float>(y),
	};
}

constexpr Size::operator Vec2() const noexcept {
	return {
		static_cast<float>(width),
		static_cast<float>(height),
	};
}

}